#!/usr/local/php/bin/php -q
<?

	if($_SERVER['argc'] > 1) {
		$fp = fopen($_SERVER['argv'][1], 'r');
		if(!$fp) die('Unable to open "' . $_SERVER['argv'][1] . '" for reading.');
	} else {
		$fp = fopen('php://stdin', 'r');
	}

	$lineNum = 0;
	$data = array();
	while(($line = fgets($fp, 4096))) {
		$byte = 0;
		for($i = 0; $i < 8; $i++) {
			if($line[$i] == '#') $byte |= 1 << $i;
		}
		$data[$lineNum++] = $byte;
	}
	fclose($fp);

	$out = null;
	for($i = 0; $i < $lineNum; $i++) {
		$out .= sprintf("%s0x%0X", (($out)?(','):('')), $data[$i]);
	}
	printf("#define HELL_LENGTH %d\n", $lineNum);
	printf("unsigned char hellData[%d] PROGMEM = {\n", $lineNum);
	printf("\t%s\n", $out);
	printf("};\n");
?>
